package com.sun.corba.se.impl.protocol;

import org.omg.CORBA.portable.OutputStream;
import com.sun.corba.se.spi.oa.NullServant;
import com.sun.corba.se.spi.oa.ObjectAdapter;
import com.sun.corba.se.spi.protocol.CorbaMessageMediator;

class NonExistent extends SpecialMethod
{
    NonExistent() {
    }
    
    @Override
    public boolean isNonExistentMethod() {
        return true;
    }
    
    @Override
    public String getName() {
        return "_non_existent";
    }
    
    @Override
    public CorbaMessageMediator invoke(Object o, CorbaMessageMediator corbaMessageMediator, byte[] array, ObjectAdapter objectAdapter) {
        int n = o == null || o instanceof NullServant;
        CorbaMessageMediator response = corbaMessageMediator.getProtocolHandler().createResponse(corbaMessageMediator, null);
        ((OutputStream)response.getOutputObject()).write_boolean((boolean)n);
        return response;
    }
}
